﻿/*----------------------------------------------*/
//  ParaFla Dan★Oniソース 
//  内部処理計算スクリプト
//                ver fd3.4.0 beta  2008/11/08
//				  ver fd3.10.0      2009/09/13
//  source by tickle
/*----------------------------------------------*/

/*----- 注意事項 ---------------------------------------------*/
// ・コメント以外の部分で、日本語は使用できません！
// 　(ParaFlaが強制終了するなどの問題が発生します)
// 
//　 何らかの事情で使いたい場合は
//　「最初の初期化」などのところで変数を作ってその変数を使用
//　 Ex.) _root.moji="処理しています";
/*------------------------------------------------------------*/

stop();
//
// ローディング表示部分
var colorMoji = "0xcccccc"; //文字色
var cy = Stage.height/2;

createTextField("mes1",1,0,cy-30,Stage.width,30);
fmt1 = new TextFormat("Westminster");
fmt1.size   = 20;
fmt1.color  = colorMoji;
fmt1.align  = "center";
mes1.setTextFormat(fmt1);

mes1.text="Now Loading...";

mes1.setTextFormat(fmt1);

createTextField("mes2",2,0,cy,Stage.width,30);
fmt2 = new TextFormat("Westminster");
fmt2.size   = 16;
fmt2.color  = colorMoji;
fmt2.align  = "center";
mes2.text   = _root.loadingMoji[0];
mes2.setTextFormat(fmt2);

/*---------------------------------------------------------------------------
 * 
 *　＜ 譜面ファイルの読み込み ＞
 *
 *　・　基本的に矢印・フリーズアローが出現するたびに
 *		矢印関係のデータは消えるので毎回初期化
 *
 *　・　7i とそれ以外で矢印の扱いが違う点に注意
 *
 *---------------------------------------------------------------------------*/
function loadNotes(){

	// 読み込み完了フラグ → OFF
	var loadOK1     = false;
	_root.loadStart = true;

	/*
 	 * ＞ 矢印の設定
 	 *
 	 *  7ikeyは他と異なる。
	 *　・　_root.hAr       　　: 矢印識別用
	 *　・　_root.steprot   　　: 各矢印の回転量 / 最初の初期化で指定
	 *　　　　　　　　　　　　　　(左矢印を基準にして各矢印が何度ずれているかを指定)
	 *　・　_root.frz_list  　　: フリーズアローの色番号
	 *　・　_root.normal_point　: 通常矢印の色番号
	 *　・　_root.naname_point  : 斜め矢印(AA)の色番号
 	 *  
 	 *---------------------------------------------------------------------------*/
	//
	// 不要なスプライトのヘッダを格納する配列
	_root.delSpr=[];
	
	if(_root.keyLabel=="7i"){
		_root.hAr          = _root.hAr7i;
		_root.steprot      = _root.STEP_ROTATiON_7i;
		_root.fList        = _root.fList7i;
		_root.delSpr.push("led","rid","fled","frid");	// 左斜め、右斜めは不要
	}else{
		_root.hAr          = _root.hArd;
		_root.steprot      = _root.STEP_ROTATiON_d;
		_root.fList        = _root.fListd;
		_root.delSpr.push("gor","iyo");		            // イヨウ、ギコは不要
	}
    /*
 	 * ＞ 譜面の読み込み
 	 *
	 *　・　arrName       　　  : 読み込みする矢印変数の名前(必要な数だけ、_dataなどは省く)
	 *　・　farrName   　　　　 : 読み込みするフリーズアローの名前
	 *
	 *　・　timeline  　　     : 矢印のタイムライン(譜面データが入る)
	 *　・　ftimeline　 　     : フリーズアローのタイムライン(譜面データが入る)
	 *　・　speedDac           : 途中変速のタイムライン(フレーム数、速度変化の順)
	 *  ・　_root.boostDac      : 個別加速のタイムライン(フレーム数、速度変化の順)
	 *  ・　_colorDac　　       : 色変化のタイムライン(フレーム数、矢印番号、カラーコードの順)
 	 *  
 	 *---------------------------------------------------------------------------*/
	var arrName =["left","leftdia","down","space","up","rightdia","right","sleft","sdown","sup","sright"];
	var farrName=["frzLeft","frzLdia","frzDown","frzSpace","frzUp","frzRdia","frzRight","sfrzLeft","sfrzDown","sfrzUp","sfrzRight"];

	timeline 	       = new Array();
	ftimeline	       = new Array();

	for(j=0;j<_root.KEY_LIMIT;j++){
		timeline[j]    = _root[arrName[j]+_root.diffin+"_data"].split(",");
		ftimeline[j]   = _root[farrName[j]+_root.diffin+"_data"].split(",");
	}
	if(_root.keyLabel==5){
		speedDac   = _root["speed"+_root.diffin+"_data"].split(",");
	} else {
		speedDac   = _root["speed"+_root.diffin+"_change"].split(",");
	}
	_root.boostDac     = _root["boost"+_root.diffin+"_data"].split(",");
	
    if(_root.changeoff=="OFF" || _root.changeoff=="Color"){
        speedDac       = [];
        _root.boostDac  = [];
	}
	/*
 	 * ＞ 矢印数の算出
 	 *
	 *　・　_root.allArrow   : 総矢印数
	 *  ・　_root.fallArrow  : 総フリーズアロー数
	 *  ・　_root.noFrz      : フリーズアローの有無をチェック(true でフリーズアロー無し)
	 *  ・　_root.del_spr    : 不要なスプライトリスト
 	 *  
 	 *---------------------------------------------------------------------------*/
	_root.allArrow=0;	 _root.fallArrow=0;
	for(j=0;j<_root.KEY_LIMIT;j++){
		if(isNaN(parseFloat(timeline[j][0]))){
			_root.delSpr.push(_root.hAr[j]);
		}else{
			_root.allArrow += timeline[j].length;
		}
		if(isNaN(parseFloat(ftimeline[j][0]))){
			_root.delSpr.push("f"+_root.hAr[j]);
		}else{
			_root.fallArrow+= ftimeline[j].length/2;	// フリーズは２つで１組
		}
	}
	_root.noFrz =(_root.fallArrow==0 ? true : false);

	/*
 	 * ＞ 各オブジェクトが最後に出てくる場所の取得
 	 *
	 *　最後の矢印またはフリーズアローがステップゾーンを通過するフレーム数をチェック
 	 *  ・　_root.framelimit    : (フレーム調整を含む)最終フレーム数
	 *
 	 *---------------------------------------------------------------------------*/
	var limitm = parseFloat(0);
	for(j=0;j<_root.KEY_LIMIT;j++){
		if(!isNaN(parseFloat(timeline[j][0]))){
			var idxn   = timeline[j].length-1;
			var limitn = parseFloat(timeline[j][idxn]);
			var chk    = limitn - limitm;
			if(chk > 0){
				limitm = limitn;
			}
		}
		if(!isNaN(parseFloat(ftimeline[j][0]))){
			var idxn   = ftimeline[j].length-1;
			var limitn = parseFloat(ftimeline[j][idxn]);
			var chk    = limitn - limitm;
			if(chk > 0){
				limitm = limitn;
			}
		}
	}

	delete idxm;	delete idxn;
	delete limitn;
	framelimit=limitm+200+_root.correction;

	/*
 	 * ＞ 途中再生(フェードイン)
 	 *
	 *　・　_root.framelimit    : 最終フレーム
	 *　・　_root.startFrame    : 譜面ファイルで指定した開始フレーム
	 *　・　_root.frame_num     : 実際に開始するフレーム番号
	 *
	 *
	 *　≪ フェードインルール ≫
	 *
	 *　・　最終フレーム ＜ 譜面ファイルで指定した開始フレーム
	 *
	 *　　　→　最終フレームを「譜面ファイルで指定した開始フレーム」＋αに変更
	 *
	 *
	 *　・　それ以外
	 *
	 *　　　→  ( 譜面ファイルで指定した開始フレーム )＋ ( 残りの長さ × swfで指定したパーセント )
	 *　　　　　を開始フレームにする
 	 *  
 	 *---------------------------------------------------------------------------*/
	_root.startUpFrame = 0;
	if(framelimit < _root.startFrame){
		_root.frameNum  = _root.startFrame;
		framelimit= 1000+Number(_root.startFrame);
	}else{
	    var fadeFrame   = Math.round(_root.fadePer/100*(framelimit-_root.startFrame))+Number(_root.startFrame);
		_root.frameNum  = fadeFrame;
	}
	_root.startUpFrame = _root.frameNum;
	
	/*
 	 * ＞ 速度変化・ストップ補正(途中再生の場合はあらかじめ位置調整)
 	 *
	 *　途中再生位置に応じて、速度変化・ストップ位置を調整
	 *　( 途中再生しない場合はこの部分は省略される )
 	 *---------------------------------------------------------------------------*/
	_root.frameNum = Number(_root.frameNum);
	var frameStart=150+_root.frameNum;
	if(_root.frameNum>0){
		if(!isNaN(parseFloat(speedDac[0]))){
			var spStart=-1;
			for(j=speedDac.length-2;j>=0;j-=2){
				if(speedDac[j]<_root.frameNum){
					spStart=j;
					break;
				}
			}
			if(spStart!=-1){
				for(j=0;j<spStart+1;j++){
					speedDac.shift();
				}
				speedDac.unshift(frameStart);
			}
		}
	}

	/*
 	 * ＞ 次の処理に必要な変数の初期化
 	 *
	 *　・　_root.mkArrow      : 各フレームの矢印番号
	 *　・　_root.mkFArrow     : 各フレームのフリーズアロー番号
	 *
	 *  ・　_root.mkColor      : 各フレームの色(矢印)番号
	 *　・　_root.mkColord     : 各フレームの色(矢印)のカラーコード
	 *
	 *  ・　_root.mkFColor     : 各フレームの色(フリーズアロー)番号
	 *　・　_root.mkFColord    : 各フレームの色(フリーズアロー)のカラーコード
	 *
 	 *---------------------------------------------------------------------------*/
	_root.mkArrow  =new Array();
	_root.mkFArrow =new Array();
	_root.mkColor  =new Array();
	_root.mkColord =new Array();
	_root.mkFColor =new Array();
	_root.mkFColord=new Array();

	mes2.text=_root.loadingMoji[1];
	mes2.setTextFormat(fmt2);

	_root.loadStart=false;
	loadOK1 = true;
	return loadOK1;
}


/*---------------------------------------------------------------------------
 * 
 *　＜ 速度を配列に変換 ＞
 *
 *　・　各フレームの速度をチェックして配列に格納
 *	・　フレーム調整分はずらして格納される
 *
 *---------------------------------------------------------------------------*/
//
// 速度を配列に変換
function storageSpd(){
	var loadOK15=false;
	_root.loadStart=true;

	var s=0;
	var spdtmp   =_root.setSpd;
	speedTmp=[];
	//
	// 速度を各フレームに格納
	for(f=0;f<=framelimit;f++){
		if(isNaN(Number(speedDac[s]))){
		}else if(f-_root.correction== speedDac[s]){
			spdtmp   = Number(speedDac[s+1])*_root.setSpd;
			if(spdtmp>_root.TOP_SPD*2){
				spdtmp=_root.TOP_SPD*2;
			}
			s+=2;
		}
		speedTmp[f]= spdtmp;
	}

	if(!isNaN(parseFloat(speedDac[0])) && speedDac[0]!=0){
		speedDac.unshift(0,1);
	}

	mes2.text=_root.loadingMoji[2];
	mes2.setTextFormat(fmt2);
	
	_root.loadStart=false;
	loadOK15 = true;
	return loadOK15;
}


/*---------------------------------------------------------------------------
 * 
 *　＜ Sp.Motion の移動設定 ＞
 *
 *　・　モーションデータを配列に格納
 *
 *---------------------------------------------------------------------------*/
function motionSpd(){
	var loadOK16=false;
	_root.loadStart=true;

    //
    // 最小倍速にあわせてモーション時間を決める
    // (0.25倍速[_root.minspdlimit]未満の場合はモーション時間が長すぎるため0.25倍速に合わせる)
	_root.motArr=new Array();
	if(_root.minMulti[_root.difCarsor]<_root.MIN_SPD_CALC){
		var minSpd   = _root.setSpd *_root.MIN_SPD_CALC;
	}else{
		var minSpd   = _root.setSpd *_root.minMulti[_root.difCarsor];
	}
	var motLimit = Math.round(_root.DIST_Y*3/minSpd)+15;
	var brkLimit =(motLimit>_root.DIST_Y/2 ? _root.DIST_Y/2 : motLimit);

	for(k=0;k<=motLimit;k++){
		_root.motArr[k] = 0;
	}

	if(_root.spMotion=="OFF"){
	}else if(_root.spMotion=="Boost"){
        //
        // [ Boost ]
        // ステップゾーンに近づくにつれて加速量が大きくなる
        // (初期倍速に影響、二次関数)
		for(k=16;k<85;k++){
			_root.motArr[k] = (85-k)*_root.setSpd/50;
		}
	}else if(_root.spMotion=="Brake"){
        //
        // [ Brake ]
        // 最初は+2、ステップゾーンに近づくにつれて加速量が小さくなる
        // (初期倍速によらず同じ、二次関数)
		for(k=20;k<34;k++){
			_root.motArr[k] = (k-15)*4/14;
		}
		for(k=34;k<brkLimit;k++){
			_root.motArr[k] = 4;
		}
	}

	mes2.text=_root.loadingMoji[3];
	mes2.setTextFormat(fmt2);
	
	_root.loadStart=false;
	loadOK16 = true;
	return loadOK16;
}

/*---------------------------------------------------------------------------
 * 
 *　＜ フレームごとの配列に変換 ＞
 *
 *　・　_root.mkArrow[300]=[0,2];
 *　　　// 300フレームで、左矢印と下矢印を作る
 *
 *　・　_root.mkFArrow[500]=[4];
 *		// 500フレームで、フリーズアロー(上)を作る
 *
 *　・　矢印データはステップゾーンに来たタイミングのフレーム数なので、
 *　　　逆算して矢印を作るタイミングのフレーム数をここで求める
 *
 *　　　実際に逆算を計算する関数は下にある「get_start」「get_bstart」関数。
 *
 *
 * ≪ 矢印・フリーズアロー・色変化 ≫
 *
 *　1. スピード変化位置のチェック
 *       
 *　　・　途中変速が無いとき
 *
 *　　　　spd_prev (速度変化開始前フレーム) : 0　　　　[最初から]
 *　　　　spd_next (速度変化後フレーム)     : Infinity [最後まで]
 *
 *　　・　途中変速があるとき
 *　　　　→ 後ろのデータからチェックする
 *　　　　
 *　　　　spd_prev :          [最後の途中変速時のフレーム数]
 *　　　　spd_next : Infinity [最後]
 *
 *　2. get_start / get_bstart 関数により、矢印の生存時間(フレーム数)を求め、
 *　　 _root.judgeY[フレーム数]に入れる
 *
 *  3-1. 最初から最後まで同じスピードのとき
 *　　　 → 2で逆算した生存時間(_root.judgeY[フレーム数])を使って逆算
 *
 *　3-2. 途中でスピードが変わるとき
 *　　　 → 2 の処理をもう一回して、矢印の生存時間を求めておく
 *
 *  　・　スピードが変わった後のフレームになるまでは _root.judgeY[フレーム数]は更新しない
 *
 *  4. 計算が終わったら、_root.mkArrow(矢印の場合)に入れる
 *
 *　　・　_root.mkArrow[(逆算で計算した)矢印を出現させるフレーム数] = [出現させる矢印の番号];
 *
 *　5. 1～4を、開始フレーム(途中再生無しの場合は最初)近くまで繰り返す
 *
 *---------------------------------------------------------------------------*/
function pushNotes(){

	var loadOK2=false;
	_root.loadStart=true;
	
	//
	// フレーム0の矢印が何フレームでステップゾーンに到達するかチェック
	var startY =0;
	var cntlim =(_root.frameNum>0 ? _root.ARROW_START_FRAME+_root.frameNum:0);
	var bstcnt =15;
	while(_root.defDistY - startY>0){
		startY += speedTmp[cntlim];
		//
		// Sp.Motionによる追加スピード（ストップを除く）
		if(speedTmp[cntlim]!=0){
			startY += _root.motArr[bstcnt];
			bstcnt++;
		}
		cntlim++;
	}

	startPoint       = new Array();   // 矢印を出すタイミング
	fstartPoint      = new Array();   // フリーズアローを出すタイミング
	_root.fLength	 = new Array();   // フリーズアローのバーの長さ
	_root.initY	     = new Array();   // 矢印の移動距離（端数を含む）
	_root.judgeY	 = new Array();   // 矢印がステップゾーンまでにかかるフレーム数
	_root.bstTime    = new Array();   // ↑でストップを除いたフレーム数。Sp.Motion用
	delFrz           = new Array();
	delFrz           = [0,0,0,0,0,0,0,0,0,0,0];

	for(j=0;j<_root.KEY_LIMIT;j++){
        //
        // 矢印をどのタイミングで出すか調べる
	 	if(!isNaN(parseFloat(timeline[j][0]))){
			startPoint[j]=new Array();
            //
            // 速度変化が無い場合の対策
			if(!isNaN(parseFloat(speedDac[0]))){
				var spdn     = speedDac.length-2;
				var spdPrev  = Number(speedDac[spdn])+_root.correction;
			}else{
				var spdPrev  = 0;
			}
			var spdnext      = Infinity;
            
            //
            // 速度変化上の問題から、後ろのデータからチェック
            // 計算し、矢印を出すタイミングを保存
			var lastn = timeline[j].length-1;
			var num   = getStart(j,lastn,timeline[j][lastn],"");

			if(_root.mkArrow[startPoint[j][lastn]]==undefined){
				_root.mkArrow[startPoint[j][lastn]]=new Array();
			}
			_root.mkArrow[startPoint[j][lastn]].push(j);

			for(k=timeline[j].length-2;k>=0;k--){
				//
				// 矢印の出現位置がマイナスになるときは除外
				if(timeline[j][k]-_root.correction<cntlim){
					break;
				//
                // 最初から最後まで同じスピードのときは
                // 計算せず前の矢印データを流用する
				}else if((timeline[j][k]-_root.judgeY[num]> spdPrev) 
					&& (timeline[j][k]< spdnext)){
					var arrFrame = timeline[j][k]-_root.judgeY[num]+_root.correction;
					startPoint[j][k]        = arrFrame;
					_root.initY[arrFrame]   = _root.initY[num];
					_root.judgeY[arrFrame]  = _root.judgeY[num];
					_root.bstTime[arrFrame] = _root.bstTime[num];
				//
				// 合間に速度変化が入るときは別途計算
				}else{
					if(timeline[j][k]< spdPrev){
						spdn     -= 2;
						spdnext  = spdPrev;
						spdPrev  = Number(speedDac[spdn])+_root.correction;
						num       = getStart(j,k,timeline[j][k],"");
					}else{
						// 返却値はダミーだがinitYなどは計算しておく
						dummyNum  = getStart(j,k,timeline[j][k],"");
					}
				}
                //
                // 矢印を出すタイミングを保存
				if(_root.mkArrow[startPoint[j][k]]==undefined){
					_root.mkArrow[startPoint[j][k]]=new Array();
				}
				_root.mkArrow[startPoint[j][k]].push(j);
			}
		}
        
        //
        // フリーズアローをどのタイミングで出すか計算
		if(!isNaN(parseFloat(ftimeline[j][0]))){
			fstartPoint[j]=new Array();
			_root.fLength[j]    =new Array();

            // 速度変化が無い場合の対策
			if(!isNaN(parseFloat(speedDac[0]))){
				var spdn     = speedDac.length-2;
				var spdPrev  = Number(speedDac[spdn])+_root.correction;
			}else{
				var spdPrev  = 0;
			}
			var spdNext      = Infinity;
            
            //
            // 速度変化上の問題から、後ろのデータからチェック
            // 矢印を出すタイミング、フリーズアローのバーの長さを計算
			var lastn = ftimeline[j].length-2;
			var num   = getStart(j,lastn,ftimeline[j][lastn],"f");
			getfLength(j,lastn);

			if(_root.mkFArrow[fstartPoint[j][lastn]]==undefined){
				_root.mkFArrow[fstartPoint[j][lastn]]=new Array();
			}
			_root.mkFArrow[fstartPoint[j][lastn]].push(j);

			for(k=ftimeline[j].length-4;k>=0;k-=2){
				//
				// フリーズアローの出現位置がマイナスになるときは除外
				if(ftimeline[j][k]-_root.correction<cntlim){
					delFrz[j] = k+2;
					break;
                //
                // 最初から最後まで同じスピードのときは
                // 計算せず前のフリーズアローデータを流用する（タイミングのみ）
				}else if((ftimeline[j][k]-_root.judgeY[num]>spdPrev)
					&&(ftimeline[j][k]<spdNext)){
					var arrFrame = ftimeline[j][k]-_root.judgeY[num]+_root.correction;
					fstartPoint[j][k] =arrFrame;
					_root.initY[arrFrame]   =_root.initY[num];
					_root.judgeY[arrFrame]  =_root.judgeY[num];
					_root.bstTime[arrFrame] =_root.bstTime[num];
				//
				// 合間に速度変化が入るときは別途計算
				}else{
					if(ftimeline[j][k]<spdPrev){
						spdn     -= 2;
						spdNext   = spdPrev; 
						spdPrev   = Number(speedDac[spdn])+_root.correction;
						num       = getStart(j,k,ftimeline[j][k],"f");
					}else{
						// 返却値はダミーだがinitYなどは計算しておく
						dummyNum  = getStart(j,k,ftimeline[j][k],"f");
					}
				}
                //
                // フリーズアローのバーの長さを計算し、
                // フリーズアローの出るタイミングを保存
				getfLength(j,k);
				if(_root.mkFArrow[fstartPoint[j][k]]==undefined){
					_root.mkFArrow[fstartPoint[j][k]]=new Array();
				}
				_root.mkFArrow[fstartPoint[j][k]].push(j);
			}
		}
	}
    //
    // 個別加速部分のタイミング調整
	if(!isNaN(parseFloat(_root.boostDac[0]))){
		delBoost=0;
		for(k=_root.boostDac.length-2;k>=0;k-=2){
			//
			// スピードの上限設定(個別加速)
			if(_root.boostDac[k+1]*speedTmp[_root.boostDac[k]]>_root.TOP_SPD*2){
				if((_root.TOP_SPD*2)/speedTmp[_root.boostDac[k]]>1){
					_root.boostDac[k+1]=(_root.TOP_SPD*2)/speedTmp[_root.boostDac[k]];
				}else{
					_root.boostDac[k+1]=1;
				}
			}
			//
			// 位置調整
			if(_root.boostDac[k]<_root.frameNum+5){
				_root.boostDac[k]=_root.frameNum+5;
				delBoost=k;
				break;
			}else{
				getBstart(k,_root.boostDac[k],"boost");
			}
		}
    }
	
    //
    // 途中変速部分を整理
	_root.arrowSpd=[];
	if(_root.frameNum==0){
		_root.arrowSpd.push(0);
		_root.arrowSpd.push(speedTmp[0]);
	}
	for(s=2;s<speedDac.length;s+=2){
        var spdFrame=Number(speedDac[s])+_root.correction;
		_root.arrowSpd.push(spdFrame-1);
		_root.arrowSpd.push(speedTmp[spdFrame]);
	}

	delete speedTmp;
	delete spdPrev;		delete spdNext;
	delete spdn;		delete num;
	
	mes2.text=_root.loadingMoji[4];
	mes2.setTextFormat(fmt2);

	_root.loadStart=false;
	loadOK2 = true;
	return loadOK2;
}

/*---------------------------------------------------------------------------
 * 
 *　＜ 規定距離に達するまでのフレーム数取得 ＞
 *
 *　・　逆算してどのタイミングで矢印を出現させるかを
 *　　　毎フレーム引き算して調べる
 *
 *---------------------------------------------------------------------------*/
//
// 規定距離に達するまでのフレーム数取得
function getStart(j,k,num,header){
	var startY =0;
	var cnt    =0;
	var bstcnt =15;
	num -= -_root.correction;

	while(_root.defDistY-startY>0){
		startY += speedTmp[num];
		//
		// Sp.Motionによる追加スピード（ストップを除く）
		if(speedTmp[num]!=0){
			startY += _root.motArr[bstcnt];
			bstcnt++;
		}
		num--;
		cnt++;
	}
	this[header+"startPoint"][j][k]=num;
	_root.initY[num]  =startY;		// 矢印の移動距離（端数を含む）
	_root.judgeY[num] =cnt;			// 矢印がステップゾーンまでにかかるフレーム数
	_root.bstTime[num]=bstcnt;		// ↑でストップを除いたフレーム数。Sp.Motion用

	return num;
}

//
// 逆算してどのタイミングで個別加速・色変化するかを計算
function getBstart(k,num,dType){
	var startY =0;
	var cnt    =0;
	var bstcnt =15;
	num -= -_root.correction;

	while(_root.defDistY-startY>0){
		startY += speedTmp[num];
		//
		// Sp.Motionによる追加スピード（ストップを除く）
		if(speedTmp[num]!=0){
			startY += _root.motArr[bstcnt];
			bstcnt++;
		}
		num--;
		cnt++;
	}
	_root[dType+"Dac"][k] =num;
    
    return cnt;
}

//
// フリーズアローの押しっぱなし部分の長さを取得
function getfLength(j,k){
	var lgth=0;
	var st=Number(ftimeline[j][k])+_root.correction;
	var en=Number(ftimeline[j][k+1])+_root.correction;
	for(fz=st;fz<en;fz++){
		lgth += speedTmp[fz];
	}
	_root.fLength[j][k]=lgth;
}

/*---------------------------------------------------------------------------
 * 
 *　＜ 不要な変数を削除 (読み込み変数 及び 一時変数) ＞
 *
 *　・　同時に、前もって初期化できる部分は初期化しておく
 *
 *---------------------------------------------------------------------------*/
function delTemporary(){

	var loadOK3=false;
	_root.loadStart=true;
	//
	// 指定フレーム以外の速度変化・ストップを削除
	for(k=0;k<delBoost;k++){
		_root.boostDac.shift();
	}

	for(j=0;j<_root.KEY_LIMIT;j++){
		for(k=0;k<delFrz[j];k++){
			_root.fLength[j].shift();
		}
		delete _root[arrName[j]+"_data"];
		delete _root[farrName[j]+"_data"];
	}
	delete _root.speed_data;
	delete _root.speed_change;
	delete _root.boost_data;
	for(k=2;k<=_root.difficulty;k++){
		for(j=0;j<_root.KEY_LIMIT;j++){
			delete _root[arrName[j]+k+"_data"];
			delete _root[farrName[j]+k+"_data"];
		}
		delete _root["speed"+k+"_data"];
		delete _root["speed"+k+"_change"];
		delete _root["boost"+k+"_data"];
	}
	delete timeline;
	delete ftimeline;
	delete startPoint;
	delete fstartPoint;
	delete speedDac;

	delete _root.keyLine;

	mes1.text="Complete!";
	mes1.setTextFormat(fmt1);
	
	//
	// 生成する矢印番号の初期化
	for(j=0;j<_root.KEY_LIMIT;j++){
		_root[_root.hAr[j]+"s"]    =0;
		_root["f"+_root.hAr[j]+"s"]=0;
	}

	// 読み込み完了フラグ → ON
	loadOK3 =true;
	return loadOK3;
}